/*
TODO: 
  make a query
  draw a Bar (3.2h*6 long by h high)
  make 6 subdivisions of the bar
  [impl both by drawing a box with fill color x and stroke black x 6]
  nope further subdivide: instead of 1 bibg box, loop which draws 12 little boxes.
  fine sub div width = 3.2h/12
  actual height is 3 h simply because space around the image is needed, simlarly, length is 7 boxes, not 6 to give a border.
*/

import de.bezier.data.sql.*;
BufferedReader queryLoader;

MySQL msql;
String query="";
String next;
int totalBooks;
int [][] perMonthTotal;
int [][][] perMonthInd;
int [] perYear;
int h = 50;
String [] labels = {"06","07","08","09","10","11","12"};


void setup(){
  noLoop();
queryLoader = createReader("Query.txt");
try{
  //load the query from file (to long for anyuthing else)
while ((next = queryLoader.readLine()) !=null)
  query+=" "+next;
} catch (IOException e){
  exit();
}


size((int)(3.2*h*8),(int)(4*h));
  
  msql = new MySQL(this, "tango.mat.ucsb.edu","spl0","mat259","V1sual1zat1on");
 if ( msql.connect() )
  {
      msql.query(query);
      msql.next();
  }
  else
  {
      // connection failed !
  }
//query done, now we need the information
perMonthTotal = new int [6][12];
perMonthInd = new int [6][12][4];
perYear = new int [6];
totalBooks = msql.getInt(1);
for (int i=0; i<6; i++){
    for (int v=0; v<12; v++){
      for (int k =0; k<4; k++){
        perMonthTotal[i][v]+=msql.getInt(2+i*48+v*4+k);
        switch (k){
        case 0:perMonthInd[i][v][0]=msql.getInt(2+i*48+v*4+k); break;
        case 1:perMonthInd[i][v][2]=msql.getInt(2+i*48+v*4+k); break;
        case 2:perMonthInd[i][v][3]=msql.getInt(2+i*48+v*4+k); break;
        case 3:perMonthInd[i][v][1]=msql.getInt(2+i*48+v*4+k); break;
        }
      }
    }
  perYear[i]=msql.getInt(1+48*6+i+1);
  }
}
/*
  draw setup loop 1-12:6 times (later 1-4:1-12:1-6
  hue varies 0 to 160
  saturation 0-125
  luminance 100, 110 120 130
*/
int offset = (int)(3.2*h);
int boxWidth = (int)(3.2*h/12);
void draw(){
  noStroke();
  for (int i=0; i<6; i++){
    for (int v=0; v<12; v++){
      int hStart =h;
       for (int k=0; k<4 ; k++){
        int he = (int)(h*perMonthInd[i][v][k]/perMonthTotal[i][v]+.5);
        int hu = (int)(180-(perYear[i]/(double)totalBooks*180)*3);
        int s = (int)(perMonthTotal[i][v]/(double)perYear[i]*255)*4;
        int b = 100+20*k;
        colorMode(HSB,255);
        fill(color(hu, s, b));
        if(k==3)
          he = 2*h-hStart;
        rect(offset+i*12*boxWidth+v*boxWidth,hStart,boxWidth,he);
        hStart+=he;
       }
    }
  }
  //tick marks
  stroke(0);
  for(int i=0; i<6; i++){
    for (int v=0; v<12; v++)
      line(offset+i*12*boxWidth+v*boxWidth,2*h+(int)(.5*h),offset+i*12*boxWidth+v*boxWidth,2*h+(int)(.4*h));
  }
  textAlign(CENTER,TOP);
  textSize(12);
  fill(0);
  for (int i=0; i<=6; i++){
    line(offset+i*12*boxWidth,2*h+(int)(.5*h),offset+i*12*boxWidth,2*h+(int)(.3*h));
    text(labels[i],offset+i*12*boxWidth,2*h+(int)(.6*h));
  }
  //
  // proposed gradient
  int hStart=h-(int)(.25*h);
  noStroke();
  for (int i=0; i<15; i++){
    int hu = (int)((180/(double)15*i));
    fill(color(hu,125,180));
    rect((int)(3.2*h*7),hStart,20,(int)(1.5*h/15));
    hStart+=(int)(1.5*h/15);
  }
  fill(0);
  stroke(0);
  textAlign(LEFT,CENTER);
  text("Percent checkout\nby year",(int)(3.2*h*7)+25,h+h/2);
  text("High",(int)(3.2*h*7)+25,h-h/4);
  text("Low",(int)(3.2*h*7)+25,2*h+h/4);
  //
  textAlign(CENTER,BOTTOM);
  textSize(16);
  text("Popularity of \"a Song of Fire and Ice\" by year and month", (int)(3.2*h*4), .75*h);

  // proposed gradient for months
  hStart=h-(int)(.25*h);
  noStroke();
  for (int i=0; i<15; i++){
    int hu = (int)(255-(255/(double)15*i));
    fill(color(0,hu,140));
    rect((int)(3.2*h)-45,hStart,20,(int)(1.5*h/15));
    hStart+=(int)(1.5*h/15);
  }
  fill(0);
  stroke(0);
  textAlign(RIGHT,CENTER);
  textSize(12);
  text("Percent checkout\nby month",(int)(3.2*h)-50,h+h/2);
  text("High",(int)(3.2*h)-50,h-h/4);
  text("Low",(int)(3.2*h)-50,2*h+h/4);
  //
  
  //add labels for the brightness values:
  noStroke();
  for(int i=0; i<4; i++){
    fill(color(0,0,100+20*i));
    rect((int)(4.8*h+(3.2*6)/4*h*i)-7,3.3*h,15,15);
    }
  stroke(0);
  fill(0);
  textAlign(LEFT,CENTER);
  text("1",4.8*h+20,3.3*h+7);
  text("2-13",4.8*h+20+(3.2*6)/4*h,3.3*h+7);
  text("14-27",4.8*h+20+(3.2*6)/4*h*2,3.3*h+7);
  text("28+",4.8*h+20+(3.2*6)/4*h*3,3.3*h+7);
  textAlign(CENTER,TOP);
  text("Duration of checkout(in days)", 3.2*h*4,3.7*h);
  //
}
